/*
 *  lutil.c - local utilities.
 *
 *  Author: Emanuel G. Noik
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "webutil.h"

/*----------------------------------------------------------------------------*/

void PrintText( char *p[] )
{
   int i;
   for( i = 0; p[i] != 0; i++ )
      printf( "%s", p[i] );
}

/*----------------------------------------------------------------------------*/

int CGIInit( entry entries[] )
{
   register int x, m = 0;
   char* s;
   int cl;

   s = getenv( "REQUEST_METHOD" );
   if( s && strcmp( s, "POST" ) )
   {
      printf( "This script should be referenced with a METHOD of POST.\n" );
      printf( "If you don't understand this, see this ");
      printf( "<a href=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</a>.%c", 10 );
      exit( 1 );
   }
   s = getenv( "CONTENT_TYPE" );
   if( s && strcmp( s, "application/x-www-form-urlencoded") )
   {
      printf( "This script can only be used to decode form results.\n" );
      exit( 1 );
   }
   s = getenv( "CONTENT_LENGTH" );
   if( s )
      cl = atoi( s );

   for( x = 0; cl && ( !feof( stdin ) ); x++ )
   {
      m = x;
      entries[x].val = fmakeword( stdin, '&', &cl );
      plustospace( entries[x].val);
      unescape_url( entries[x].val );
      entries[x].name = makeword( entries[x].val, '=' );
   }
   return m;
}

/*----------------------------------------------------------------------------*/

ulong pow2( int p )
{
   if( p <= 0 ) return( 1 );
   else return( 2 * pow2( p - 1 ) );
}

/*----------------------------------------------------------------------------*/

int root2( ulong i )
{
   if( i >= 2 ) return( 1 + root2( i / 2 ) );
   else return( 0 );
}

/*----------------------------------------------------------------------------*/

void lowercase( char* s )
{
   int i;
   for( i = 0; s[i] != 0; i++ )
      if( isalpha( s[i] ) && isupper( s[i] ) ) s[i] = tolower( s[i] );
}

/*----------------------------------------------------------------------------*/

int stringIndex( char* s, char* ss[] )
{
   int i;
   for( i = 0; ss[i] != 0; i++ )
      if( strcmp( s, ss[i] ) == 0 )
         return( i );
   return( -1 );
}

/*----------------------------------------------------------------------------*/

char* CommaNumber( ulong i )
{
   ulong j = i;
   char s[32], t[32];
   s[0] = 0;
   while( j > 999 )
   {
      sprintf( t, ",%03ld%s", j % 1000, s );
      strcpy( s, t );
      j /= 1000;
   }
   sprintf( t, "%ld%s", j, s );
   return strdup( t );
}

/*----------------------------------------------------------------------------*/

ulong SetBit( ulong m, int i )
{
   return m | (ulong)((ulong)1 << i );
}

ulong ClrBit( ulong m, int i )
{
   return m & (ulong)( (ulong)0xffffffff - ((ulong)1 << i) );
}

/*----------------------------------------------------------------------------*/

void ParseArg( int *first, int *maxhits, int *m, char* arg, entry entries[] )
{
   int j;
   char name[256], *value;
   if( sscanf( arg, "first:%d", &j ) == 1 )
   {
      *first = j;
      if( *first < 0 ) *first = 0;
   }
   else if( sscanf( arg, "maxhits:%d", &j ) == 1 )
   {
      *maxhits = j;
      if( *maxhits < 0 ) *maxhits = 0;
   }
   else
   {
      sscanf( arg, "%[^:]:", name );
      value = arg+strlen(name)+1;
      entries[*m].name = strdup( name );
      entries[*m].val  = strdup( value );
      (*m)++;
   }
}

/*----------------------------------------------------------------------------*/
