#
#  restaura.awk  Ver 1.0
#
#  <C> Copyright 1995 Symbiotic Solutions
#  Authors:  Emanuel Noik
#
#  This code may look like awk but it's actually gawk!
#
#-------------------------------------------------------------------------------

BEGIN {
   FS="|";		# field separator
   n = 0;		# number of hits

   print "<html><header>";
   print "<title>Search the RedBook - Query Results</title>";
   print "</header>";
   print "<body>";
   print "<h2>Query Results</h2>";

   dbInit();		# initialize database package
   dbMaxHits=5;		# set default maximum hits (temporary)

   dbField(1,  "S", "" )			# organization
   dbField(2,  "S", "" )			# level1
   dbField(3,  "S", "" )			# level2
   dbField(4,  "S", "" )			# level3
   dbField(5,  "S", "" )			# level4
   dbField(6,  "S", "" )			# contact
   dbField(7,  "S", "" )			# street
   dbField(8,  "L", "redbook/cities.txt" )	# city
   dbField(9,  "L", "redbook/provinces.txt" )	# prov
   dbField(10, "S", "" )			# postal
   dbField(11, "S", "" )			# telephone
   dbField(12, "S", "" )			# description
   dbField(13, "S", "" )			# url
   dbField(14, "S", "" )			# logo
   dbField(15, "S", "" )			# email

   dbArgs();
}

{
   if( NR < dbOffset ) next;	# skip records

   if( n == dbMaxHits )		# only show dbMaxHits
   {
      dbMoreHits( "/cgi-bin/rb" );
      exit;
   }

   if( myFilter() )
   {
      print "<hr>"
      print n+1 ". "
      if( $6 != "" ) print $6 "<br>"
      if( $1 != "" ) print $1 "<br>"
      if( $8 != 0  )
      {
         if( $7 != "" ) print $7 "<br>"
         print ml[8,$8] ", " ml[9,$9] "<br>"
         if( $10 != "" ) print $10 "<br>"
      }
      if( $11 != "" ) print $11 "<br>"
      if( $12 != "" ) print "<blockquote>" $12 "</blockquote>"

      n++;
   }
}

function myFilter() {
   return ( dbFilterI(1)  > -1 && \
            dbFilterI(7)  > -1 && \
            dbFilterI(8)  > -1 && \
            dbFilterI(12) > -1 \
          ) ? 1 : 0;
}

END {
   if( dbErr )
   {
      print "Received bad data from form, your browser may be too old!";
   }
   else
   {
      print "<hr size=\"2\">";
      dbFooter();
      print "</body></html>";
   }
}

#-------------------------------------------------------------------------------
