#
#  tradesho.awk  Ver 1.0
#
#  <C> Copyright 1995 Symbiotic Solutions
#  Authors:  Emanuel Noik
#
#  This code may look like awk but it's actually gawk!
#
#-------------------------------------------------------------------------------

BEGIN {
   FS="|";		# field separator
   n = 0;		# number of hits

   print "<html><header>";
   print "<title>Search the RedBook - Search Results</title>";
   print "</header>";
   print "<body>";
   print "<h2>Search Results</h2>";

   dbInit();		# initialize database package
   dbMaxHits=10;	# set default maximum hits (temporary)

   dbField( 1,  "M", "tradesho/types.txt" )	# type
   dbField( 2,  "S", "" )			# title
   dbField( 3,  "S", "" )			# venue
   dbField( 4,  "L", "tradesho/countries.txt" )	# show country
   dbField( 5,  "L", "tradesho/regions.txt" )	# show region
   dbField( 6,  "D", "" )			# date
   #        7,  "N", ""				# duration
   #        8,  "N", "" )			# participants
   #        9,  "N", "" )			# exhibition
   #       10,  "N", "" )			# exhibitors
   #       11,  "S", "" )			# freq
   #       12,  "N", "" )			# boothnr
   #       13,  "N", "" )			# totsqmt
   #       14,  "N", "" )			# netsqmt
   #       15,  "N", "" )			# costsqmt
   #       16,  "S", "" )			# currency
   #       17,  "S", "" )			# contact
   #       18,  "S", "" )			# company
   #       19,  "L", "tradesho/countries.txt" )	# c_country
   #       20,  "S", "" )			# c_city
   #       21,  "S", "" )			# street
   #       22,  "S", "" )			# postal
   #       23,  "S", "" )			# tel_code
   #       24,  "S", "" )			# tel
   #       25,  "S", "" )			# fax
   #       26,  "S", "" )			# telex

   dbArgs();
}

{
   if( NR < dbOffset ) next;	# skip records

   if( n == dbMaxHits )		# only show dbMaxHits
   {
      dbMoreHits( "/cgi-bin/tradesho" );
      exit;
   }

   if( myFilter() )
   {
      print "<hr><dl>";
      print "<dt><i><b>Title:</b></i><dd>" $2
      print "<dt><i><b>Venue:</b></i><dd>" $3
      print "<dt><i><b>Date:</b></i><dd>" substr($6,1,4) "/" \
         substr($6,5,2) "/" substr($6,7,2)
      if( $7 != "0" ) print "Duration: " $7 " days";
      print "<dt><i><b>Contact:</b></i><dd>";
         if( $17 != "" ) print $17 "<br>";
         if( $18 != "" ) print $18 "<br>"
         if( $21 != "" ) print $21 "<br>"
         if( $20 != "" ) print $20 " "
         if( $22 != "" ) print $22
         print "<br>"
         if( $19 != "" ) print ml[4,$19] "<br>"
         if( $24 != "" ) print "Tel: " $23 " " $24
         if( $25 != "" ) print "Fax: " $23 " " $25
      print "</dl>";

      n++;
   }
}

function myFilter() {
   return ( dbFilterI(1) > -1 && \
            dbFilterI(2) > -1 && \
            dbFilterI(3) > -1 && \
            ( dbFilterI(4) + dbFilterI(5) ) > -1 && \
            dbFilterI(6) > -1 \
          ) ? 1 : 0;
}

END {
   if( dbErr )
   {
      print "Received bad data from form, your browser may be too old!";
   }
   else
   {
      print "<hr size=\"2\">";
      dbFooter();
      print "</body></html>";
   }
}

#-------------------------------------------------------------------------------
